Legrand / Raritan Xerus™ JSON-RPC API for Remote Access Devices like KX4-101, KX3G2

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
bulkcfg::BulkConfiguration Interface Reference

Bulk Configuration Interface. More...

`import "BulkConfiguration.idl";`

## Classes
struct | Filter
| This structure defines a filter. More...
struct | FilterProfile
| Filter profiles are named collections of filters. More...
struct | RestoredEvent
| Event: Bulk configuration restored (also used for restoring config backup) More...
struct | SavedEvent
| Event: Bulk configuration saved (also used for saving config backup) More...
struct | Settings
| Settings. More...
struct | SettingsChangedEvent
| Event: Bulk configuration settings changed. More...

## Public Types
enum | Status { UNKNOWN , UPLOAD_FAILED , RESTORE_PENDING , RESTORE_OK , RESTORE_FAILED }
| Status of the last bulk configuration restore operation. More...
enum | FilterType { WHITELIST , BLACKLIST }
| These are the supported supported filter types. More...

## Public Member Functions
void | getStatus (out Status status, out time timeStamp)
| Retrieve the status of the last bulk configuration restore operation.
vector< Filter > | getFilters ()
| Retrieve the list of supported filters.
vector< FilterProfile > | getFilterProfiles ()
| Retrieve the configured filter profiles.
int | addFilterProfile (in FilterProfile profile)
| Add a new filter profile.
int | modifyFilterProfile (in FilterProfile profile)
| Modify an existing filter profile.
int | deleteFilterProfile (in string profileName)
| Delete an existing filter profile.
string | getDefaultFilterProfileName ()
| Retrieve the name of the currently selected default profile.
int | selectDefaultFilterProfile (in string profileName)
| Select a new default filter profile.
Settings | getSettings ()
| Get settings.
int | setSettings (in Settings settings)
| Set settings.

## Public Attributes
constant int | SUCCESS = 0
| Error codes.
constant int | ERR_FILTER_NAME_UNKNOWN = 1
| A referenced filter name is unknown.
constant int | ERR_FILTER_TYPE_READONLY = 2
| A referenced filter can't be overridden.
constant int | ERR_PROFILE_ALREADY_EXISTS = 3
| A profile with the given name already exists.
constant int | ERR_PROFILE_DOES_NOT_EXIST = 4
| A profile with the given name does not exist.
constant int | ERR_PROFILE_IS_DEFAULT = 5
| The selected profile is the current default profile.
constant int | ERR_PROFILE_IS_BUILTIN = 6
| The selected profile is the builtin profile.
constant int | ERR_PROFILE_NAME_TOO_LONG = 7
| The profile name is too long.
constant int | ERR_PROFILE_NAME_INVALID = 8
| The profile name contains invalid characters.
constant int | ERR_PROFILE_TOO_MANY = 9
| The maximum number of profiles already exist.

## Detailed Description

Bulk Configuration Interface.

Definition at line 12 of file BulkConfiguration.idl.

## Member Enumeration Documentation

## ◆ FilterType

enum bulkcfg::BulkConfiguration::FilterType

These are the supported supported filter types.

Enumerator
WHITELIST | Whitelist filter (value is part of the bulk configuration)
BLACKLIST | Blacklist filter (value is not part of the bulk configuration)

Definition at line 35 of file BulkConfiguration.idl.

## ◆ Status

enum bulkcfg::BulkConfiguration::Status

Status of the last bulk configuration restore operation.

Enumerator
UNKNOWN | No bulk configuration was done yet.
UPLOAD_FAILED | Uploading a bulk configuration failed.
RESTORE_PENDING | Restore is pending.
RESTORE_OK | Restoring bulk configuration successful.
RESTORE_FAILED | Restoring bulk configuration failed.

Definition at line 15 of file BulkConfiguration.idl.

## Member Function Documentation

## ◆ addFilterProfile()

int bulkcfg::BulkConfiguration::addFilterProfile | ( | in FilterProfile | profile | ) |

Add a new filter profile.

Parameters

  profile | The new filter profile

Returns
  SUCCESS if OK
  ERR_FILTER_NAME_UNKNOWN if a referenced filter name is unknown
  ERR_FILTER_TYPE_READONLY if a referenced filter can't be overridden
  ERR_PROFILE_ALREADY_EXISTS if a profile with the given name already exists
  ERR_PROFILE_IS_BUILTIN if the selected profile is the builtin profile
  ERR_PROFILE_NAME_TOO_LONG if the profile name is too long
  ERR_PROFILE_NAME_INVALID if the profile name contains invalid characters
  ERR_PROFILE_TOO_MANY if the maximum number of profiles already exist

## ◆ deleteFilterProfile()

int bulkcfg::BulkConfiguration::deleteFilterProfile | ( | in string | profileName | ) |

Delete an existing filter profile.

Parameters

  profileName | The name of the profile to be deleted

Returns
  SUCCESS if OK
  ERR_PROFILE_DOES_NOT_EXIST if a profile with the given name does not exist
  ERR_PROFILE_IS_DEFAULT if the selected profile is the current default profile
  ERR_PROFILE_IS_BUILTIN if the selected profile is the builtin profile

## ◆ getDefaultFilterProfileName()

string bulkcfg::BulkConfiguration::getDefaultFilterProfileName | ( |  | ) |

Retrieve the name of the currently selected default profile.

Returns
  The name of the current default profile

## ◆ getFilterProfiles()

vector< FilterProfile > bulkcfg::BulkConfiguration::getFilterProfiles | ( |  | ) |

Retrieve the configured filter profiles.

Returns
  List of filter profiles

## ◆ getFilters()

vector< Filter > bulkcfg::BulkConfiguration::getFilters | ( |  | ) |

Retrieve the list of supported filters.

Returns
  List of supported filters

## ◆ getSettings()

Settings bulkcfg::BulkConfiguration::getSettings | ( |  | ) |

Get settings.

Returns
  Settings

## ◆ getStatus()

void bulkcfg::BulkConfiguration::getStatus | ( | out Status | status,
|  | out time | timeStamp )

Retrieve the status of the last bulk configuration restore operation.

Parameters

  status | Result: Bulk configuration restore status
  timeStamp | Result: Time of last restore operation (UNIX timestamp, UTC)

## ◆ modifyFilterProfile()

int bulkcfg::BulkConfiguration::modifyFilterProfile | ( | in FilterProfile | profile | ) |

Modify an existing filter profile.

Parameters

  profile | The updated filter profile

Returns
  SUCCESS if OK
  ERR_FILTER_NAME_UNKNOWN if a referenced filter name is unknown
  ERR_FILTER_TYPE_READONLY if a referenced filter can't be overridden
  ERR_PROFILE_DOES_NOT_EXIST if a profile with the given name does not exist
  ERR_PROFILE_IS_BUILTIN if the selected profile is the builtin profile

## ◆ selectDefaultFilterProfile()

int bulkcfg::BulkConfiguration::selectDefaultFilterProfile | ( | in string | profileName | ) |

Select a new default filter profile.

Parameters

  profileName | The name of the new default profile

Returns
  SUCCESS if OK
  ERR_PROFILE_DOES_NOT_EXIST if a profile with the given name does not exist

## ◆ setSettings()

int bulkcfg::BulkConfiguration::setSettings | ( | in Settings | settings | ) |

Set settings.

NOTE: The builtin profile will be ignored when present in the list of filter profiles.

Parameters

  settings | The settings to set

Returns
  SUCCESS if OK
  ERR_FILTER_NAME_UNKNOWN if a referenced filter name is unknown
  ERR_FILTER_TYPE_READONLY if a referenced filter can't be overridden
  ERR_PROFILE_ALREADY_EXISTS if the settings contain multiple profiles with the same name
  ERR_PROFILE_NAME_TOO_LONG if the profile name is too long
  ERR_PROFILE_NAME_INVALID if the profile name contains invalid characters
  ERR_PROFILE_TOO_MANY if the settings contain too many profiles
  ERR_PROFILE_DOES_NOT_EXIST if a profile with the given name does not exist

## Member Data Documentation

## ◆ ERR_FILTER_NAME_UNKNOWN

constant int bulkcfg::BulkConfiguration::ERR_FILTER_NAME_UNKNOWN = 1

A referenced filter name is unknown.

Definition at line 90 of file BulkConfiguration.idl.

## ◆ ERR_FILTER_TYPE_READONLY

constant int bulkcfg::BulkConfiguration::ERR_FILTER_TYPE_READONLY = 2

A referenced filter can't be overridden.

Definition at line 91 of file BulkConfiguration.idl.

## ◆ ERR_PROFILE_ALREADY_EXISTS

constant int bulkcfg::BulkConfiguration::ERR_PROFILE_ALREADY_EXISTS = 3

A profile with the given name already exists.

Definition at line 92 of file BulkConfiguration.idl.

## ◆ ERR_PROFILE_DOES_NOT_EXIST

constant int bulkcfg::BulkConfiguration::ERR_PROFILE_DOES_NOT_EXIST = 4

A profile with the given name does not exist.

Definition at line 93 of file BulkConfiguration.idl.

## ◆ ERR_PROFILE_IS_BUILTIN

constant int bulkcfg::BulkConfiguration::ERR_PROFILE_IS_BUILTIN = 6

The selected profile is the builtin profile.

Definition at line 95 of file BulkConfiguration.idl.

## ◆ ERR_PROFILE_IS_DEFAULT

constant int bulkcfg::BulkConfiguration::ERR_PROFILE_IS_DEFAULT = 5

The selected profile is the current default profile.

Definition at line 94 of file BulkConfiguration.idl.

## ◆ ERR_PROFILE_NAME_INVALID

constant int bulkcfg::BulkConfiguration::ERR_PROFILE_NAME_INVALID = 8

The profile name contains invalid characters.

Definition at line 97 of file BulkConfiguration.idl.

## ◆ ERR_PROFILE_NAME_TOO_LONG

constant int bulkcfg::BulkConfiguration::ERR_PROFILE_NAME_TOO_LONG = 7

The profile name is too long.

Definition at line 96 of file BulkConfiguration.idl.

## ◆ ERR_PROFILE_TOO_MANY

constant int bulkcfg::BulkConfiguration::ERR_PROFILE_TOO_MANY = 9

The maximum number of profiles already exist.

Definition at line 98 of file BulkConfiguration.idl.

## ◆ SUCCESS

constant int bulkcfg::BulkConfiguration::SUCCESS = 0

Error codes.

The operation was successful

Definition at line 89 of file BulkConfiguration.idl.

The documentation for this interface was generated from the following file:

- BulkConfiguration.idl